<template>
  <div class="gradebook-wrapper">
    <div @click="downloadGradeBook()" class="gradebook-download">
      <i class="bx bx-cloud-download"></i>
      Дафтарчаи бақайдгирии соатҳои <br />
      кредитиро зеркашӣ намоед
    </div>
    <div class="gradebook" ref="document">
      <div class="gradebook-info">
        <div class="gradebook-info__title">
          <img :src="$auth.user.avatar" />
          <span>Зачетная книжка</span>
        </div>
        <ul>
          <li>
            <span> Насаб, ном ва номи падар </span>
            <div>
              {{ $auth.user.name }}
            </div>
          </li>
          <li>
            <span> Рӯзи таваллуд </span>
            <div>
              {{ $auth.user.birthday }}
            </div>
          </li>
          <li>
            <span> Ҷои кор </span>
            <div>
              {{ $auth.user.workplace }}
            </div>
          </li>
          <li>
            <span> Вазифа </span>
            <div>
              {{ $auth.user.specialization }}
            </div>
          </li>
          <li>
            <span> Таҷрибаи кори (солона): тибби умумӣ </span>
            <div>
              {{ $auth.user.experience }}
            </div>
          </li>
          <li v-if="$auth.user.family_doctor_category_year">
            <span> Пдар тибби оилавӣ </span>
            <div>
              {{ $auth.user.family_doctor_category_year }}
            </div>
          </li>
          <li v-if="$auth.user.family_doctor_category">
            <span> Дараҷанокии тахассусии тибби оилавӣ </span>
            <div>
              {{ $auth.user.family_doctor_category }}
            </div>
          </li>
        </ul>
      </div>
      <div class="gradebook-assignments">
        <table border="1" width="100%">
          <thead>
            <tr>
              <th>№</th>
              <th>Рӯйхати чорабиниҳо</th>
              <th>Мавзӯъ</th>
              <th>Санаи гузаронидан</th>
              <th>Миқдори чорабинӣ</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="(item, id) in exercises_list_done" :key="item._id">
              <td>{{ id + 1 }}</td>
              <td>{{ item.type_exercise }}</td>
              <td>{{ item.category }}</td>
              <td>{{ item.date.substring(0, 10) }}</td>
              <td>{{ item.credit }}</td>
            </tr>
            <tr>
              <td colspan="4">Ҳамагӣ соатҳои кредитӣ</td>
              <td>
                {{ count_of_credits(exercises_list_done) }}
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  layout: "profile",
  middleware: "auth",
  data() {
    return {
      exercises_list_done: [],
    };
  },
  fetchOnServer: false,
  fetch() {
    this.getExercises();
  },
  computed: {
    count_of_credits() {
      return (list) => {
        let count = 0;
        list.forEach((item) => {
          count += parseInt(item.credit);
        });
        return count;
      };
    },
  },
  methods: {
    goToExercise(url) {
      this.$router.push(url);
    },
    getExercises() {
      this.$axios
        .$post("/exercise/getUserExercises", { user_id: this.$auth.user._id })
        .then(({ exercises_done }) => {
          if (exercises_done.length > 0) {
            this.exercises_list_done = exercises_done;
          }
        })
        .catch((error) => {
          console.log(error);
        });
    },
    downloadGradeBook() {
      this.$html2pdf(this.$refs.document, {
        margin: 1,
        filename: "file-name.pdf",
        image: { type: "jpeg", quality: 1 },
        html2canvas: {
          scale: 1,
          dpi: 192,
          letterRendering: true,
          ignoreElements: true,
        },
        jsPDF: { unit: "pt", format: "a2", orientation: "portrait" },
      });
    },
  },
};
</script>

<style lang="scss" scoped>
.gradebook-wrapper {
  margin-left: 20px;
  background-color: #fff;
  @include less-than(tablet) {
    margin-left: 0px;
  }
}
.gradebook-download {
  font-size: 36px;

  width: 100%;
  cursor: pointer;
  transition: all ease 0.3s;
  padding: 20px 30px;
  display: flex;
  &:hover {
    color: #0c63e4;
  }
  i {
    margin-right: 10px;
    padding-top: 1px;
  }
  b {
    margin-left: 5px;
  }
}
.gradebook {
  background-color: #fff;
  width: 100%;
  padding: 60px 200px;
  font-size: 20px;

  &-info {
    ul {
      width: 100%;
      margin-top: 60px;
    }
    li {
      margin: 20px 0;
      width: 100%;
      display: grid;
      grid-template-columns: auto 1fr;
      span {
        display: block;
      }
      div {
        text-align: center;
        border-bottom: 1px solid #000;
        height: fit-content;
      }
    }
  }
  &-info__title {
    display: flex;
    align-items: center;
    width: 100%;
    img {
      width: 250px;
      height: 250px;
      object-fit: contain;
      border: 1px solid #ccc;
    }
    span {
      flex: auto;
      font-size: 40px;
      text-align: center;
      text-transform: uppercase;
      font-weight: 900;
    }
  }

  &-assignments {
    margin-top: 60px;
    td {
      text-align: center;
    }
  }
}
</style>
